//
//  GOCarBrandViewController.m
//  GODiagnoseDemo
//
//  Created by Launch Tech Co.,Ltd on 10/9/15.
//  Copyright (c) 2015 allen. All rights reserved.
//

#import "GOCarBrandViewController.h"
#import "GONetworkRequest.h"
#import "UIViewController+Extension.h"

@interface GOCarBrandViewController ()<UITableViewDataSource,UITableViewDelegate>

@property (nonatomic ,strong)UITableView *carBrandTableView;
@property (nonatomic ,strong)NSMutableArray *carFatherBrandArr;
@property (nonatomic ,strong)NSMutableArray *carSonBrandArr;
@property (nonatomic ,assign)BOOL flag;
@end

@implementation GOCarBrandViewController

- (NSMutableArray *)carFatherBrandArr{

    if (!_carFatherBrandArr) {
        
        _carFatherBrandArr = [[NSMutableArray alloc]init];
    }
    return _carFatherBrandArr;
}
- (NSMutableArray *)carSonBrandArr{

    if (!_carSonBrandArr) {
        
        _carSonBrandArr = [[NSMutableArray alloc]init];
    }
    return _carSonBrandArr;
}
- (void)viewDidLoad {
    [super viewDidLoad];
    self.carBrandTableView = [[UITableView alloc]initWithFrame:self.view.bounds style:UITableViewStylePlain];
    self.carBrandTableView.delegate = self;
    self.carBrandTableView.dataSource = self;
    [self.view addSubview:self.carBrandTableView];
}

- (void)viewWillAppear:(BOOL)animated{

    [super viewWillAppear:YES];
    [self getCarBrand];
}

// 获取车的品牌
- (void)getCarBrand{
    
    NSString *timeStr = [NSString stringWithFormat:@"%ld",(long)[[NSDate date] timeIntervalSince1970]]; // 获取当前时间戳
    NSString *tempStr = [NSString stringWithFormat:@"%@%@",timeStr,DEVELOP_KEY];
    // 加密参数
    NSDictionary *signParams = @{@"access_id":self.access_id,
                                 @"access_token":self.access_token,
                                 @"action":@"forjth.getbrandid",
                                 @"app_id":@"2013120200000001",
                                 @"develop_id":DEVELOP_ID,
                                 @"time":tempStr};
    NSString *sign = [self signWithParamsForiDiag:signParams];
    // 请求参数
    NSDictionary *params = @{@"action":@"forjth.getbrandid",
                             @"develop_id":DEVELOP_ID,
                             @"app_id":@"2013120200000001",
                             @"access_id":self.access_id,
                             @"access_token":self.access_token,
                             @"time":timeStr,
                             @"sign":sign};
    [GONetworkRequest networkGetCarBrand:params requestSuccess:^(id responseObject) {
        
        self.carFatherBrandArr = responseObject;
        [self.carBrandTableView reloadData];
    } requestFailure:^(id responseObject) {
        
        
    }];
}

#pragma mark - UITableView代理方法
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{

    if (self.flag) {
        
        return self.carSonBrandArr.count;
    }
    return self.carFatherBrandArr.count;
}
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{

    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"cell"];
    cell.accessoryType = UITableViewCellAccessoryNone;
    if (!cell) {
        
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:@"cell"];
    }
    if ([[self.carFatherBrandArr[indexPath.row] valueForKey:@"subList"] count] != 0) {
        
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
    }
    if (self.flag) {
        
        cell.textLabel.text = [self.carSonBrandArr[indexPath.row] valueForKey:@"carSeriesName"];
    }else{
        cell.textLabel.text = [self.carFatherBrandArr[indexPath.row] valueForKey:@"carSeriesName"];}
    return cell;
}
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    
    if ([[self.carFatherBrandArr[indexPath.row] valueForKey:@"subList"] count] != 0) {
        
        self.flag = 1;
        self.carSonBrandArr = [self.carFatherBrandArr[indexPath.row] valueForKey:@"subList"];
        [self.carBrandTableView reloadData];
        return;
    }
    if (self.sendBlock) {
        
        if (self.flag) {
            
            NSString *carSeriesId = [self.carSonBrandArr[indexPath.row] valueForKey:@"carSeriesId"];
            NSString *carSeriesName = [self.carSonBrandArr[indexPath.row] valueForKey:@"carSeriesName"];
            self.sendBlock(carSeriesId,carSeriesName);
            [self.navigationController popViewControllerAnimated:YES];
        }else{
            NSString *carSeriesId = [self.carFatherBrandArr[indexPath.row] valueForKey:@"carSeriesId"];
            NSString *carSeriesName = [self.carFatherBrandArr[indexPath.row] valueForKey:@"carSeriesName"];
            self.sendBlock(carSeriesId,carSeriesName);
            [self.navigationController popViewControllerAnimated:YES];}
    }
}

@end
