//
//  GOCarTypeViewController.m
//  GODiagnoseDemo
//
//  Created by Launch Tech Co.,Ltd on 10/9/15.
//  Copyright (c) 2015 allen. All rights reserved.
//

#import "GOCarTypeViewController.h"
#import "GONetworkRequest.h"
@interface GOCarTypeViewController ()<UITableViewDelegate,UITableViewDataSource>

@property (nonatomic ,strong)UITableView *carTypeTableView;
@property (nonatomic ,strong)NSMutableArray *carTypeArr;

@end

@implementation GOCarTypeViewController

- (NSMutableArray *)carTypeArr{

    if (!_carTypeArr) {
        
        _carTypeArr = [[NSMutableArray alloc]init];
    }
    return _carTypeArr;
}
- (void)viewDidLoad {
    [super viewDidLoad];
    self.carTypeTableView = [[UITableView alloc]initWithFrame:self.view.bounds style:UITableViewStylePlain];
    self.carTypeTableView.delegate = self;
    self.carTypeTableView.dataSource = self;
    [self.view addSubview:self.carTypeTableView];
    [self getCarType];
}

// 获取车型
- (void)getCarType{
    
    NSDictionary *params = @{@"action":@"mine_car_service.query_market_car_type",
                             @"lan_id_or_name":@"cn",
                             @"detailId":self.carSeriesId,};
    [GONetworkRequest networkGetCarType:params requestSuccess:^(id responseObject) {
        
        self.carTypeArr = responseObject;
        [self.carTypeTableView reloadData];
    } requestFailure:^(id responseObject) {
        
        
    }];
}

#pragma mark -- UITableView代理方法

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{

    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{

    return self.carTypeArr.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{

    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"cell"];
    
    if (!cell) {
        
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"cell"];
    }
    cell.textLabel.text = self.carTypeArr[indexPath.row];
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{

    if (self.carTypeSendBlock) {
        
        NSString *carTypeStr = self.carTypeArr[indexPath.row];
        self.carTypeSendBlock(carTypeStr);
        [self.navigationController popViewControllerAnimated:YES];
    }
}

@end
