//
//  GOFillCarInfoController.m
//  GODiagnoseDemo
//
//  Created by Launch Tech Co.,Ltd on 10/9/15.
//  Copyright (c) 2015 allen. All rights reserved.
//

#import "GOFillCarInfoController.h"
#import "GOCarBrandViewController.h"
#import "GOCarTypeViewController.h"
#import "GOCarConfigureController.h"
#import "GOCarConfigureController.h"
#import "GONetworkRequest.h"
#import "MBProgressHUD+Golo.h"
#import "UIViewController+Extension.h"
#define selfWidth self.view.bounds.size.width
#define selfHeight self.view.bounds.size.height

static NSString * const reuseIdentifier = @"Cell";
@interface GOFillCarInfoController ()<UITextFieldDelegate,UICollectionViewDelegate,UICollectionViewDataSource,UICollectionViewDelegateFlowLayout>

@property (weak, nonatomic) IBOutlet UILabel *carBrandName;
@property (weak, nonatomic) IBOutlet UILabel *carTypeName;
@property (weak, nonatomic) IBOutlet UITextField *goloSeriesId;
@property (weak, nonatomic) IBOutlet UITextField *goloPasswd;
@property (weak, nonatomic) IBOutlet UITextField *carLicenceNum;
@property (weak, nonatomic) IBOutlet UITextField *preCarPlateLB;
@property (weak, nonatomic) IBOutlet UITextField *carVinCode;
@property (weak, nonatomic) IBOutlet UITextField *carDisplacement;
@property (weak, nonatomic) IBOutlet UISegmentedControl *carGearbox;
@property (weak, nonatomic) IBOutlet UITextField *carProducingYear;
@property (nonatomic ,copy) NSString *carGearboxStr;
@property (nonatomic ,copy) NSString *carBrandNumStr;
@property (nonatomic ,copy) NSString *tempCarSeriesId;
@property (nonatomic ,strong) UICollectionView *provinceCollectionVC;
@property (nonatomic ,strong) NSArray *provinceArray;
@property (nonatomic ,strong) MBProgressHUD *hud;


@end

@implementation GOFillCarInfoController

- (NSArray *)provinceArray{

    if (!_provinceArray) {
        
        _provinceArray = [[NSArray alloc]init];
    }
    return _provinceArray;
}
- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.goloSeriesId.delegate = self;
    self.goloPasswd.delegate = self;
    self.preCarPlateLB.delegate = self;
    self.carVinCode.delegate = self;
    self.carDisplacement.delegate = self;
    self.carProducingYear.delegate = self;
    [self getProvinceAndCarProduceYear];
    [self loadCollectionViewLayout];
    self.carGearbox.selectedSegmentIndex = 0;
    self.carGearboxStr = [NSString stringWithFormat:@"%ld",(long)self.carGearbox.selectedSegmentIndex];// 默认置为自动挡
    [self.carGearbox addTarget:self action:@selector(changeCarGearbox) forControlEvents:UIControlEventValueChanged];
    UIGestureRecognizer *tap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(resetView)];
    [self.view addGestureRecognizer:tap];

}
// 获取车辆品牌
- (IBAction)getCarBrandAction:(UIButton *)sender {
    
    GOCarBrandViewController *carBrandCtl = [[GOCarBrandViewController alloc]init];
    carBrandCtl.sendBlock = ^(NSString *carSeriesId , NSString *carSeriesName){
    
        self.tempCarSeriesId = carSeriesId;
        self.carBrandName.text = carSeriesName;
    };
    carBrandCtl.access_id = self.access_id;
    carBrandCtl.access_token = self.access_token;
    [self.navigationController pushViewController:carBrandCtl animated:YES];
}
// 获取车型
- (IBAction)getCarSeriesAction:(UIButton *)sender {
    
    if (self.tempCarSeriesId) {
        
        GOCarTypeViewController *carTypeCtl = [[GOCarTypeViewController alloc]init];
        carTypeCtl.carSeriesId = self.tempCarSeriesId;
        carTypeCtl.carTypeSendBlock = ^(NSString *carTypeStr){
        
            self.carTypeName.text = carTypeStr;
        };
        [self.navigationController pushViewController:carTypeCtl animated:YES];
    }
}
// 绑定接头
- (IBAction)activateGoloAndCar:(UIButton *)sender {
    
    if (self.goloSeriesId.text.length  != 0 &&
        self.goloPasswd.text.length    != 0 &&
        self.carBrandName.text.length  != 0 &&
        self.carLicenceNum.text.length != 0 &&
        self.carVinCode.text.length    != 0) {
        
        self.carBrandNumStr = [NSString stringWithFormat:@"%@%@",self.preCarPlateLB.text,self.carLicenceNum.text];
        [self activateGoloAndCarRequest];
        
    }else{
        
        [self tipsMessage:@"绑定接头失败" tips:@"请正确填写各项信息"];
    }
    
}

#pragma mark -- 网络请求
// 将车辆信息和golo头绑定的请求
- (void)activateGoloAndCarRequest{
    
    [self animationLoadShow];
    NSString *timeStr = [NSString stringWithFormat:@"%ld",(long)[[NSDate date] timeIntervalSince1970]]; // 获取当前时间戳
    NSString *tempStr = [NSString stringWithFormat:@"%@%@",timeStr,DEVELOP_KEY];
    
    NSDictionary *signParams = @{@"access_id":self.access_id,
                                 @"access_token":self.access_token,
                                 @"action":@"forjth.save_car_config",
                                 @"app_id":@"2013120200000001",
                                 @"car_carcase_num":self.carVinCode.text, //vin码
                                 @"car_displacement":self.carDisplacement.text,// 排量
                                 @"car_gearbox_type":self.carGearboxStr,   // 档，  0手动 1自动 默认自动
                                 @"car_producing_year":self.carProducingYear.text,// 年款
                                 @"car_type_id":self.carTypeName.text,//self.carTypeName.text, // 车型
                                 @"code_id":self.tempCarSeriesId,// 车辆品牌ID
                                 @"develop_id":DEVELOP_ID, //
                                 @"display_lan":@"cn", // 中文
                                 @"mine_car_plate_num":self.carBrandNumStr, // 车牌号
                                 @"password":self.goloPasswd.text,//@"57080705", golo头密码
                                 @"serial_no":self.goloSeriesId.text,//@"967790037885", // golo头序列号
                                 @"time":tempStr};
    NSString *sign = [self signWithParamsForiDiag:signParams];
    
    NSDictionary *params = @{@"action":@"forjth.save_car_config",
                             @"develop_id":DEVELOP_ID,
                             @"mine_car_plate_num":self.carBrandNumStr,
                             @"code_id":self.tempCarSeriesId,
                             @"serial_no":self.goloSeriesId.text,
                             @"car_carcase_num":self.carVinCode.text,
                             @"app_id":@"2013120200000001",
                             @"display_lan":@"cn", // 中文
                             @"car_type_id":self.carTypeName.text,//self.carTypeName.text, // 车型
                             @"car_producing_year":self.carProducingYear.text,// 年款
                             @"car_displacement":self.carDisplacement.text,// 排量
                             @"car_gearbox_type":self.carGearboxStr,   // 档，  0手动 1自动 默认自动
                             @"password":self.goloPasswd.text,//self.goloPasswd.text, // golo头密码
                             @"access_id":self.access_id,
                             @"access_token":self.access_token,
                             @"time":timeStr,
                             @"sign":sign};
    
    [GONetworkRequest networkActivateGolo:params requestSuccess:^(id responseObject) {
        
        self.hud.hidden = YES;
        if([[responseObject valueForKey:@"code"] integerValue] == 0){
            
            [self tipsMessage:@"提示" tips:@"绑定成功"];
            [self getCarConfigParamRequest];
        }else{
        
            NSString *tipsStr = [responseObject valueForKey:@"msg"];
            [self tipsMessage:@"提示" tips:tipsStr];
            
        }
    } requestFailure:^(id responseObject) {
        
        [self tipsMessage:@"提示" tips:@"网络故障请检查网络"];
    }];
}
// 请求配置文件下载需要的参赛
- (void)getCarConfigParamRequest{
    
    NSString *timeStr = [NSString stringWithFormat:@"%ld",(long)[[NSDate date] timeIntervalSince1970]]; // 获取当前时间戳
    NSString *tempStr = [NSString stringWithFormat:@"%@%@",timeStr,DEVELOP_KEY];
    
    NSDictionary *signParams = @{@"action":@"data_develop.get_car_eobd",
                                 @"app_id":@"2013120200000001",
                                 @"develop_id":DEVELOP_ID,
                                 @"serial_no":self.goloSeriesId.text,//@"970190023394",// // golo头序列号
                                 @"time":tempStr};
    NSString *sign = [self signWithParamsForiDiag:signParams];
    
    NSDictionary *params = @{@"action":@"data_develop.get_car_eobd",
                             @"app_id":@"2013120200000001",
                             @"develop_id":DEVELOP_ID,
                             @"serial_no":self.goloSeriesId.text,
                             @"time":timeStr,
                             @"sign":sign};
    
    [GONetworkRequest networkGetCarConfigParam:params requestSuccess:^(id responseObject) {
        
        if ([[responseObject valueForKey:@"code"] integerValue] == 0) {
            
            NSDictionary *dic = [responseObject valueForKey:@"data"];
            GOCarConfigureController *carConfigCtl = [[GOCarConfigureController alloc]init];
            carConfigCtl.goloSeriesId = self.goloSeriesId.text;
            carConfigCtl.ccUserId = [NSString stringWithFormat:@"%@",dic[@"user_id"]];
            carConfigCtl.vdConfigId = [NSString stringWithFormat:@"%@",dic[@"configId"]];
            carConfigCtl.eobdConfigId = [NSString stringWithFormat:@"%@",dic[@"obd_config"]];
            carConfigCtl.eobdSign = [NSString stringWithFormat:@"%@",dic[@"obd_sign"]];
            carConfigCtl.confSign = [NSString stringWithFormat:@"%@",dic[@"sign"]];
            [self.navigationController pushViewController:carConfigCtl animated:YES];
            
        }else{
            
            NSString *msg = [responseObject valueForKey:@"msg"];
            [self tipsMessage:@"提示" tips:msg];
        }
    } requestFailure:^(id responseObject) {
        
        [self tipsMessage:@"提示" tips:@"网络故障请检查网络"];
    }];
}
#pragma mark - 自动和手动的切换
- (void)changeCarGearbox{
    
    self.carGearboxStr = [NSString stringWithFormat:@"%ld",(long)self.carGearbox.selectedSegmentIndex];
}

#pragma mark -- 车牌视图布局
- (void)loadCollectionViewLayout{

    UICollectionViewFlowLayout *lineLayOut = [[UICollectionViewFlowLayout alloc] init];
    lineLayOut.scrollDirection = UICollectionViewScrollDirectionVertical;
    lineLayOut.itemSize = CGSizeMake(30., 30.);
    lineLayOut.sectionInset = UIEdgeInsetsMake(5., 5., 5., 5.);
    lineLayOut.minimumLineSpacing = 2.5;
    lineLayOut.minimumInteritemSpacing = 2.5;
    if (self.provinceCollectionVC == nil) {
        self.provinceCollectionVC = [[UICollectionView alloc] initWithFrame:CGRectMake(0, 200, 320, 140.) collectionViewLayout:lineLayOut];
        [self.provinceCollectionVC registerClass:[UICollectionViewCell class] forCellWithReuseIdentifier:reuseIdentifier];
        self.provinceCollectionVC.delegate   = self;
        self.provinceCollectionVC.dataSource = self;
        self.provinceCollectionVC.backgroundColor = [UIColor colorWithRed:205./255. green:205./255. blue:205./255. alpha:1.];
    }
    self.preCarPlateLB.inputView = _provinceCollectionVC;
}

#pragma mark -- UITextField代理方法
- (BOOL)textFieldShouldBeginEditing:(UITextField *)textField{
    
    if (textField.tag != 10) {
        
        [UIView animateWithDuration:0.3 animations:^{
            
            self.view.frame = CGRectMake(0, -150, selfWidth,selfHeight );
        }];
    }
    return YES;
}
- (void)resetView{

    [self.view endEditing:YES];
    [UIView animateWithDuration:0.3 animations:^{
        
        self.view.frame = CGRectMake(0, 0, selfWidth,selfHeight );
    }];
}

#pragma mark -- UICollectionView代理方法
- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView {
    return 1;
}

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {
    return self.provinceArray.count;
}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {
    UICollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:reuseIdentifier forIndexPath:indexPath];
    cell.backgroundColor = [UIColor whiteColor];
    
    UILabel *label = (UILabel *)[cell viewWithTag:1000];
    if (nil == label) {
        label = [[UILabel alloc] initWithFrame:cell.bounds];
        label.backgroundColor = [UIColor clearColor];
        label.textAlignment = NSTextAlignmentCenter;
        label.font = [UIFont systemFontOfSize:16.];
        label.tag = 1000;
    }
    
    label.text =[_provinceArray objectAtIndex:indexPath.row];
    [cell addSubview:label];
    
    return cell;
}
- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath
{
    self.preCarPlateLB.text = [_provinceArray objectAtIndex:indexPath.row];
}
//获取省份
- (void)getProvinceAndCarProduceYear
{
    NSURL *plistUrl = [[NSBundle mainBundle] URLForResource:@"GOCarPreProvinceAndProduceYear" withExtension:@"plist"];
    NSDictionary *plist = [NSDictionary dictionaryWithContentsOfURL:plistUrl];
    self.provinceArray = [plist valueForKey:@"province"];
    
}
// 加载动画
- (void)animationLoadShow{
    
    self.hud = [MBProgressHUD showHudOnView:self.view animated:YES];
    self.hud.hidden = NO;
    self.hud.labelText = @"请稍等...";
}

@end
