//
//  GONetworkRequest.m
//  GODiagnoseDemo
//
//  Created by Launch Tech Co.,Ltd on 9/30/15.
//  Copyright (c) 2015 allen. All rights reserved.
//

#import "GONetworkRequest.h"
#import "AFNetworking.h"
#import "GOCarBrandFatherModel.h"
@implementation GONetworkRequest

// 注册请求
+ (void)networkRegisterProduct:(id)params requestSuccess:(RequestSuccess)requestSuccess requestFailure:(RequestFailure)requestFailure{
    
    AFHTTPRequestOperationManager *manger = [AFHTTPRequestOperationManager manager];
    manger.requestSerializer = [AFHTTPRequestSerializer serializer];
    manger.responseSerializer = [AFHTTPResponseSerializer serializer];
    [manger GET:REGISTERPRODUCT_URL parameters:params success:^(AFHTTPRequestOperation * operation, id responseObject) {
        
        NSDictionary *receiveDic = [NSJSONSerialization JSONObjectWithData:responseObject options:NSJSONReadingMutableContainers error:nil];
        requestSuccess (receiveDic);
        
    } failure:^(AFHTTPRequestOperation * operation, NSError * error) {
        
        requestFailure (error);
    }];
}

// 获取车辆品牌请求
+ (void)networkGetCarBrand:(id)params requestSuccess:(RequestSuccess)requestSuccess requestFailure:(RequestFailure)requestFailure{
    
    AFHTTPRequestOperationManager *manger = [AFHTTPRequestOperationManager manager];
    manger.requestSerializer = [AFHTTPRequestSerializer serializer];
    manger.responseSerializer = [AFHTTPResponseSerializer serializer];
    [manger GET:GETCARBRAND_URL parameters:params success:^(AFHTTPRequestOperation * operation, id responseObject) {
        
        NSMutableArray *receiveArr = [NSJSONSerialization JSONObjectWithData:responseObject options:NSJSONReadingMutableContainers error:nil];
        NSMutableArray *dataArr = [[NSMutableArray alloc]init];
        for (NSDictionary *dic in receiveArr) {
            
            GOCarBrandFatherModel *carBrandFatherModel = [[GOCarBrandFatherModel alloc]init];
            [carBrandFatherModel setValuesForKeysWithDictionary:dic];
            [dataArr addObject:carBrandFatherModel];
        }
        requestSuccess (dataArr);
        
    } failure:^(AFHTTPRequestOperation * operation, NSError * error) {
        
        requestFailure (error);
    }];
}

// 获取车辆的类型请求
+ (void)networkGetCarType:(id)params requestSuccess:(RequestSuccess)requestSuccess requestFailure:(RequestFailure)requestFailure{
    
    AFHTTPRequestOperationManager *manger = [AFHTTPRequestOperationManager manager];
    manger.requestSerializer = [AFHTTPRequestSerializer serializer];
    manger.responseSerializer = [AFHTTPResponseSerializer serializer];
    [manger GET:GETCARTYPE_URL parameters:params success:^(AFHTTPRequestOperation * operation, id responseObject) {
        
        NSDictionary *receiveDic = [NSJSONSerialization JSONObjectWithData:responseObject options:NSJSONReadingMutableContainers error:nil];
        NSMutableArray *dataArr = [[NSMutableArray alloc]init];
        for (NSMutableDictionary *dic in receiveDic[@"data"]) {
            
            if ([dic[@"carType"] length] == 0) {
                
                dic[@"carType"] = dic[@"detailName"];
            }
            [dataArr addObject:dic[@"carType"]];
        }
        requestSuccess (dataArr);
        
    } failure:^(AFHTTPRequestOperation * operation, NSError * error) {
        
        requestFailure (error);
    }];
}

// 激活golo头请求
+ (void)networkActivateGolo:(id)params requestSuccess:(RequestSuccess)requestSuccess requestFailure:(RequestFailure)requestFailure{
    
    AFHTTPRequestOperationManager *manger = [AFHTTPRequestOperationManager manager];
    manger.requestSerializer = [AFHTTPRequestSerializer serializer];
    manger.responseSerializer = [AFHTTPResponseSerializer serializer];
    [manger GET:ACTIVATEGOLO_URL parameters:params success:^(AFHTTPRequestOperation * operation, id responseObject) {
        
        NSDictionary *receiveDic = [NSJSONSerialization JSONObjectWithData:responseObject options:NSJSONReadingMutableContainers error:nil];
        requestSuccess (receiveDic);
        
    } failure:^(AFHTTPRequestOperation * operation, NSError * error) {
        
        requestFailure (error);
    }];
}

// 根据golo盒子获取下载配置文件所需要的参数请求
+ (void)networkGetCarConfigParam:(id)params requestSuccess:(RequestSuccess)requestSuccess requestFailure:(RequestFailure)requestFailure{
    
    AFHTTPRequestOperationManager *manger = [AFHTTPRequestOperationManager manager];
    manger.requestSerializer = [AFHTTPRequestSerializer serializer];
    manger.responseSerializer = [AFHTTPResponseSerializer serializer];
    [manger GET:GETCARCONFIGPARAM_URL parameters:params success:^(AFHTTPRequestOperation * operation, id responseObject) {
        
        NSDictionary *receiveDic = [NSJSONSerialization JSONObjectWithData:responseObject options:NSJSONReadingMutableContainers error:nil];
        requestSuccess (receiveDic);
        
    } failure:^(AFHTTPRequestOperation * operation, NSError * error) {
        
        requestFailure (error);
    }];
}
// 获取sys.ini文件参数
+ (void)networkGetCarSysiniParam:(id)params requestSuccess:(RequestSuccess)requestSuccess requestFailure:(RequestFailure)requestFailure{
    
    AFHTTPRequestOperationManager *manger = [AFHTTPRequestOperationManager manager];
    manger.requestSerializer = [AFHTTPRequestSerializer serializer];
    manger.responseSerializer = [AFHTTPResponseSerializer serializer];
    [manger GET:GETCARSYSINIPARAM_URL parameters:params success:^(AFHTTPRequestOperation * operation, id responseObject) {
        
        NSDictionary *receiveDic = [NSJSONSerialization JSONObjectWithData:responseObject options:NSJSONReadingMutableContainers error:nil];
        requestSuccess (receiveDic);
        
    } failure:^(AFHTTPRequestOperation * operation, NSError * error) {
        
        requestFailure (error);
    }];
}
// 获取激活车辆信息请求
+ (void)networkGetActivatedCarInfo:(id)params requestSuccess:(RequestSuccess)requestSuccess requestFailure:(RequestFailure)requestFailure{
    
    AFHTTPRequestOperationManager *manger = [AFHTTPRequestOperationManager manager];
    manger.requestSerializer = [AFHTTPRequestSerializer serializer];
    manger.responseSerializer = [AFHTTPResponseSerializer serializer];
    [manger GET:GETACTIVATEDCARINFO_URL parameters:params success:^(AFHTTPRequestOperation * operation, id responseObject) {
        
        NSDictionary *receiveDic = [NSJSONSerialization JSONObjectWithData:responseObject options:NSJSONReadingMutableContainers error:nil];
        requestSuccess (receiveDic);
        
    } failure:^(AFHTTPRequestOperation * operation, NSError * error) {
        
        requestFailure (error);
    }];
    
}

// 取消注册请求
+ (void)networkCancelRegisterProduct:(id)params requestSuccess:(RequestSuccess)requestSuccess requestFailure:(RequestFailure)requestFailure{
    
    AFHTTPRequestOperationManager *manger = [AFHTTPRequestOperationManager manager];
    manger.requestSerializer = [AFHTTPRequestSerializer serializer];
    manger.responseSerializer = [AFHTTPResponseSerializer serializer];
    [manger GET:CANCELREGISTER_URL parameters:params success:^(AFHTTPRequestOperation * operation, id responseObject) {
        
        NSDictionary *receiveDic = [NSJSONSerialization JSONObjectWithData:responseObject options:NSJSONReadingMutableContainers error:nil];
        requestSuccess (receiveDic);
        
    } failure:^(AFHTTPRequestOperation * operation, NSError * error) {
        
        requestFailure (error);
    }];
}



@end
