//
//  GOReportDetailViewController.m
//  golo
//
//  Created by launch06 on 13-12-30.
//  Copyright (c) 2013年 LAUNCH. All rights reserved.
//

#import "GOReportDetailViewController.h"
#import "GODiagnoseCommon.h"
@interface GOReportDetailViewController ()
@end

@implementation GOReportDetailViewController

- (id)initWithReportDic:(NSDictionary *)dic
{
    self = [super initWithNibName:@"GOReportDetailViewController" bundle:nil];
    if (self) {
        self.reportDic = dic;
    }
    
    return self;
}

//- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
//{
//    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
//    if (self) {
//        // Custom initialization
//    }
//    return self;
//}
- (void)dealloc
{
    self.webV = nil;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    [self setupTitle];
    [self setupContent];
   
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}



- (void)setupTitle
{
    
}
- (void)setupContent
{
        _webV = [[UIWebView alloc] initWithFrame:self.view.bounds];
        NSMutableString *html = [self HTMLReportHeadWithReportDic:_reportDic];
        html = [self HTMLReportBodyTitleDivWithHTML:html reportDic:_reportDic];
        html = [self HTMLReportBodyFaultTableDivWithHTML:html reportDic:_reportDic];
        html = [self HTMLReportBodyDataflowTableDivWithHTML:html reportDic:_reportDic];
        [html appendString:@"</body></html>"];
        [_webV loadHTMLString:html baseURL:nil];
        [self.view addSubview:_webV];
}


- (NSMutableString *)HTMLReportHeadWithReportDic:(NSDictionary *)report
{
    NSMutableString *html = [NSMutableString stringWithFormat:@"<html><head><title>%@</title>", @"体检报告"];
    [html appendString:@"<style>body{background-color:#eee;padding:0;} h2 {text-align:center;}      \
     p{font-size:15;margin:2px;} table{border:none;} thead{color:#409A8B;font-size:15;}             \
     tr{font-size:14;} .sub_title{color:#409A8B;font-size:16;} .sub_title span{padding-right:10%;}  \
     .dash_line {border:1px #ccc dashed;}</style></head>"];
    
    return html;
}

- (NSMutableString *)HTMLReportBodyTitleDivWithHTML:(NSMutableString *)html reportDic:(NSDictionary *)report
{
    [html appendFormat:@"<body><h2>%@</h2>", @"体检报告"];
    NSString *time;
//    NSDictionary * reportContent = [ _reportDic objectForKey:kReportContent];
    time = [NSString stringWithFormat:@"%@: %@", NSLocalizedString(@"GOMV_ExamTime", nil), [NSDate date]];
    [html appendFormat:@"<div><p>%@</p>", time];
    [html appendFormat:@"<p>%@</p>", [NSString stringWithFormat:@"%@：%@", NSLocalizedString(@"GOMV_VehicleBrand", nil), @"Demo"]];
    [html appendFormat:@"<p>%@</p>", [NSString stringWithFormat:@"%@：%@", NSLocalizedString(@"GOMV_CarModel", nil), @"跑车"]];
    [html appendFormat:@"<p>%@</p>", [NSString stringWithFormat:@"%@：%@", NSLocalizedString(@"GOMV_CarModelYear", nil), @"2014"]];
    [html appendFormat:@"<p>%@</p>", [NSString stringWithFormat:@"%@：%@", NSLocalizedString(@"GOMV_CarVIN", nil), @"01234567891234567"]];
    [html appendFormat:@"<p>%@</p>", [NSString stringWithFormat:@"%@：%@", NSLocalizedString(@"GOMV_CarTransmission", nil), @"自动变速箱"]];
    [html appendFormat:@"<p>%@</p></div>", [NSString stringWithFormat:@"%@：%@", NSLocalizedString(@"GOMV_CarDisplacement", nil), @"5.0L"]];
    
    return html;
}

- (NSMutableString *)HTMLReportBodyFaultTableDivWithHTML:(NSMutableString *)html reportDic:(NSDictionary *)report
{
    NSArray *faultList = [report objectForKey:kGODiagFaultCodeList];
    [html appendString:@"<hr class=\"dash_line\"/>"];
    [html appendFormat:@"<div><div class=\"sub_title\"><span>%@(%d)</span><span>%@(%d)</span></div>",
     NSLocalizedString(@"GOMV_FaultCodeCount", nil), [report[kGODiagFaultCodeCount]intValue], NSLocalizedString(@"GOMV_DataflowCount", nil), [report[kGODiagDataStreamCount]intValue]];
    [html appendFormat:@"<div class=\"sub_title\">%@:</div>", NSLocalizedString(@"GOMV_FaultCode", nil)];
    
    [html appendFormat:@"<table width=\"100%%\"><thead><tr><td width=\"50%%\">%@</td><td width=\"50%%\">%@</td></tr></thead>",NSLocalizedString(@"GOMV_FaultSys", nil), NSLocalizedString(@"GOMV_FaultStatus", nil)];
    for (int i = 0; i < faultList.count; i++) {
        NSDictionary *tmpDic = [faultList objectAtIndex:i];
        NSArray *faultCodeDetailArr = [tmpDic objectForKey:kGODiagFaultCodeDetail];
         if (faultCodeDetailArr.count > 0 ) {
              [html appendFormat:@"<tr><td>%@</td><td>%@</td></tr>",[tmpDic objectForKey:kGODiagFaultCodeSystem],@"不良"];
        } else{
              [html appendFormat:@"<tr><td>%@</td><td>%@</td></tr>",[tmpDic objectForKey:kGODiagFaultCodeSystem],@"正常"];
        }
    }
    [html appendString:@"</table></div>"];
    
    
    [html appendFormat:@"<table width=\"100%%\"><thead><tr><td width=\"15%%\">%@</td><td width=\"15%%\">%@</td><td>%@</td><td width=\"15%%\">%@</td></tr></thead>",NSLocalizedString(@"GOMV_FaultSys", nil),
     NSLocalizedString(@"GOMV_FaultCode", nil), NSLocalizedString(@"GOMV_FaultDes", nil), NSLocalizedString(@"GOMV_FaultStatus", nil)];
    for (int i = 0; i < faultList.count; i++)
    {
        NSDictionary *tmpDic = [faultList objectAtIndex:i];
        NSArray *faultCodeDetailArr = [tmpDic objectForKey:kGODiagFaultCodeDetail];
        if (faultCodeDetailArr.count > 0 ) {
            for (int j = 0 ; j < faultCodeDetailArr.count; j ++ ) {
                NSDictionary *faults = [faultCodeDetailArr objectAtIndex:j];
                [html appendFormat:@"<tr><td>%@</td><td>%@</td><td>%@</td><td>%@</td></tr>",[tmpDic objectForKey:kGODiagFaultCodeSystem],
                 [faults objectForKey:kGODiagFaultCodeName], [faults objectForKey:kGODiagFaultCodeDesc], [faults objectForKey:kGODiagFaultCodeState]];
            }
        }
    }
    [html appendString:@"</table></div>"];
    
    return html;
}

- (NSMutableString *)HTMLReportBodyDataflowTableDivWithHTML:(NSMutableString *)html reportDic:(NSDictionary *)report
{
    NSArray *dataflows = [report objectForKey:kGODiagDataStreamList];
    [html appendString:@"<hr class=\"dash_line\"/>"];
    [html appendFormat:@"<div><div class=\"sub_title\">%@:(%@)</div>",
     NSLocalizedString(@"GOMV_Dataflow", nil), NSLocalizedString(@"GOMV_DataflowPrompts", nil)];
    [html appendFormat:@"<table width=\"100%%\"><thead><tr><td width=\"15%%\">%@</td><td>%@</td><td width=\"15%%\">%@</td></tr></thead>",
     NSLocalizedString(@"GOMV_DataflowSeq", nil), NSLocalizedString(@"GOMV_DataflowName", nil), NSLocalizedString(@"GOMV_DataflowValue", nil)];
    for (int i = 0; i < dataflows.count; i++) {
        NSDictionary *dataflow = dataflows[i];
        NSString *dataStremNamdAndUnit;
        if ([[dataflow objectForKey:kGODiagDataStreamUnit] length] > 0) {
            dataStremNamdAndUnit = [NSString stringWithFormat:@"%@(%@)",[dataflow objectForKey:kGODiagDataStreamName],[dataflow objectForKey:kGODiagDataStreamUnit]];
        }
        else
        {
            dataStremNamdAndUnit = [dataflow objectForKey:kGODiagDataStreamName];
        }
        
        //编号 数据流名称 输出值
        [html appendFormat:@"<tr><td>%d</td><td>%@</td><td>%@</td></tr>",
         i+1, dataStremNamdAndUnit,[dataflow objectForKey:kGODiagDataStreamValue]];
    }
    [html appendString:@"</table></div>"];
    return html;
}

@end
