//
//  ViewController.m
//  GODiagnoseDemo
//
//  Created by allen on 14/12/26.
//  Copyright (c) 2014年 allen. All rights reserved.
//

#import "InspectViewController.h"
#import "GOInspectionDiag.h"
#import "MBProgressHUD+Golo.h"
#import "GOReportDetailViewController.h"
#import "Config.h"

@interface InspectViewController ()<GOInspectionDiagDelegate>
{
    MBProgressHUD *_hud;
    GOReportDetailViewController *_reportVC;
    GOInspectionDiag *_inspection;
}
@property (nonatomic,strong) NSString *carBrandPath;
@property (nonatomic,strong) NSString *EOBDPth;
@property (nonatomic,strong) NSString *snKey;
@end

@implementation InspectViewController

-(void)dealloc{
    [_inspection inspectionCancel];
}
- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    _inspection = [GOInspectionDiag shareInstance];
    _inspection.delegate = self;
    _progressView.progress = 0;
    _progressContentLabel.text = @"";
    _progressContentLabel.textAlignment = NSTextAlignmentCenter;
    _progressLabel.text = @"";
    _progressLabel.textAlignment = NSTextAlignmentCenter;
    NSDictionary *unzipInfoDic = [[NSUserDefaults standardUserDefaults] valueForKey:kSerialNoKey(self.goloSeriesId)];
    _carBrandPath = PATH_IN_DOCUMENTS_DIR(unzipInfoDic[CARDIAGSOFT_PATH_KEY]);
    _EOBDPth = PATH_IN_DOCUMENTS_DIR(unzipInfoDic[CAREOBDSOFT_PATH_KEY]);
}

#pragma mark -  button action－－－－

- (IBAction) startInspection:(UIButton *)sender
{
    [self.view endEditing:YES];
    
    // 开始体检
    [_inspection inspectionStart:_goloSeriesId
                    carBrandPath:_carBrandPath
                         EOBDPth:_EOBDPth];
}

// 一键清码
- (IBAction)oneKeyClearCode:(UIButton *)sender {
    
    [self.view endEditing:YES];    
    [_inspection oneKeyClearReportHandle:_goloSeriesId
                            carBrandPath:_carBrandPath
                                 EOBDPth:_EOBDPth];
}

- (IBAction)cancelInspection:(UIButton *)sender
{
    _hud.hidden = YES;
    _progressView.progress = 0;
    _progressContentLabel.text = @"";
    _progressLabel.text = @"";
    [_inspection inspectionCancel];
}

- (void)showHudWithAnimated:(BOOL)animated
{
    _hud = [MBProgressHUD showHudOnView:self.view animated:animated];
}

#pragma mark -  GOInspectionDiagDelegate－－－－－－－－－－－－－－－－
- (void)inspectionWillConectDiag
{
    [self showHudWithAnimated:YES];
    _hud.labelText = @"正在与诊断服务建立连接中...";
    _hud.hidden = NO;
}

- (void)inspectioncConectDiagFinsh
{
    _hud.hidden = YES;
}
- (void)inspectionDiagScanProcess:(NSDictionary *)data
{
    NSLog(@"scanData = %@",data);
    _progressContentLabel.text = [NSString stringWithFormat:@"%@(%@)",data[kGODiagProgressTitle], data[kGODiagProgressContent]];
    _progressLabel.text = [NSString stringWithFormat:@"%@%%", data[kGODiagProgressPercentage]];
    _progressView.progress = [data[kGODiagProgressPercentage]intValue]/100.0;
}

- (void)inspectionDiagResult:(NSDictionary *)data
{
    _progressView.progress = 0;
    _progressContentLabel.text = @"";
    _progressLabel.text = @"";
    _reportVC.reportDic = data;
    
    [self showHudWithAnimated:YES];
    _hud.hidden = NO;
    _hud.labelText = @"正在生成报告...";
    _reportVC = [[GOReportDetailViewController alloc]initWithReportDic:data];
    _reportVC.view.tag = 100000;
    UIView *view = [_reportView viewWithTag:100000];
    [view removeFromSuperview];
    _hud.hidden = YES;
    [_reportView addSubview:_reportVC.view];
}

- (void)inspectionDiagError:(NSError *)error
{
    _hud.hidden = YES;
    [self showAertWithTitle:@"体检"
                    message:[error localizedDescription]];
}

- (void)showAertWithTitle:(NSString *)title
                  message:(NSString *)message
{
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:title
                                                    message:message
                                                   delegate:nil
                                          cancelButtonTitle:@"确定"
                                          otherButtonTitles:nil, nil];
    [alert show];
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}
@end
