//
//  MBProgressHUD+MBProgressHUD_Golo.m
//  golo
//
//  Created by launch05 on 14-3-31.
//  Copyright (c) 2014年 LAUNCH. All rights reserved.
//

#import "MBProgressHUD+Golo.h"
#import "MBProgressHUD.h"

@interface MBProgressHUD ()

@property(nonatomic, strong) MBProgressHUD *progressHUD;

@end

@implementation MBProgressHUD (Golo)

+ (MBProgressHUD *)HUDWithGolo:(UIView *)view
{
    MBProgressHUD *hud = [MBProgressHUD showHUDAddedTo:view animated:NO];
    hud.removeFromSuperViewOnHide = NO;
    hud.dimBackground = YES;
    hud.userInteractionEnabled = YES;
    UIImageView *animateView = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"loading_icon"]];
    hud.mode = MBProgressHUDModeCustomView;
    hud.customView = animateView;
    hud.opacity = 0.5f;
    NSString *animationKey = @"rotationAnimation";
    [hud.customView.layer removeAnimationForKey:animationKey];
    CABasicAnimation* rotationAnimation;
    rotationAnimation = [CABasicAnimation animationWithKeyPath:@"transform.rotation.z"];
    rotationAnimation.toValue = [NSNumber numberWithFloat:2 * M_PI];
    rotationAnimation.duration = 3.0;
    rotationAnimation.cumulative = YES;
    rotationAnimation.repeatCount = INFINITY;
    
    [hud.customView.layer addAnimation:rotationAnimation forKey:animationKey];
    
    return hud;
}

#pragma mark - progressHUD

+ (MBProgressHUD *)showHudOnView:(UIView *)view animated:(BOOL)animated
{
    MBProgressHUD *hud = [self HUDForView:view];
    if (!hud)
    {
        hud = [MBProgressHUD showHUDAddedTo:view animated:NO];
        hud.removeFromSuperViewOnHide = NO;
        hud.dimBackground = NO;
        hud.userInteractionEnabled = YES;
        UIImageView *animateView = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"loading_icon"]];
        hud.mode = MBProgressHUDModeCustomView;
        hud.customView = animateView;
        hud.opacity = 0.5f;
    }
    
    NSString *animationKey = @"rotationAnimation";
    UIView *hudView = hud.customView;
    [hudView.layer removeAnimationForKey:animationKey];
    CABasicAnimation* rotationAnimation;
    rotationAnimation = [CABasicAnimation animationWithKeyPath:@"transform.rotation.z"];
    rotationAnimation.toValue = [NSNumber numberWithFloat:2 * M_PI];
    rotationAnimation.duration = 3;
    rotationAnimation.cumulative = YES;
    rotationAnimation.repeatCount = INFINITY;
    [hudView.layer addAnimation:rotationAnimation forKey:animationKey];
    [view bringSubviewToFront:hud];
    [hud show:animated];
    
    return hud;
}



@end
