//
//  GOSleepSettingViewController.m
//  GODiagnoseDemo
//
//  Created by Launch Tech Co.,Ltd on 4/8/15.
//  Copyright (c) 2015 allen. All rights reserved.
//

#import "GOSleepSettingViewController.h"
#import "WIFIPasswordSetting.h"

@interface GOSleepSettingViewController () <UITableViewDataSource, UITabBarDelegate> {
    NSArray* arr;
    WIFIPasswordSetting* _wifiPWsetting;
    NSString* selectedSleepTime; //选中的时间
    NSInteger selectedIndex;
}
@end

@implementation GOSleepSettingViewController
- (void)dealloc
{
    NSLog(@"%s", __func__);
    [WIFIPasswordSetting closeWIFISocket]; //出了控制器关掉WIFISocket
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"确定"
                                                                              style:UIBarButtonItemStylePlain
                                                                             target:self
                                                                             action:@selector(btnSubmitClick)];
    selectedIndex = -1;
    arr = [NSArray arrayWithObjects:@"5", @"15", @"30", @"45", @"60", nil];
    self.tableView.allowsMultipleSelectionDuringEditing = YES;
    self.tableView.editing = YES;
    [self getSleepTime];
}

#pragma mark -tableviewDelegate and DataSource
- (NSInteger)numberOfSectionsInTableView:(UITableView*)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView*)tableView numberOfRowsInSection:(NSInteger)section
{
    return arr.count;
}

- (UITableViewCell*)tableView:(UITableView*)tableView cellForRowAtIndexPath:(NSIndexPath*)indexPath
{
    static NSString* CellIdentifier = @"Cell";
    UITableViewCell* cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];

    if (!cell) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    NSString *tempMinute = arr[indexPath.row];
    cell.textLabel.text = [NSString stringWithFormat:@"%@分钟",tempMinute];
    if ([tempMinute isEqualToString:selectedSleepTime]) {
        selectedIndex = indexPath.row;
        [self.tableView selectRowAtIndexPath:[NSIndexPath indexPathForRow:indexPath.row inSection:0] animated:YES scrollPosition:UITableViewScrollPositionNone];
    }
    cell.accessoryType = UITableViewCellAccessoryNone;
    cell.backgroundColor = [UIColor clearColor];

    return cell;
}

- (CGFloat)tableView:(UITableView*)tableView heightForRowAtIndexPath:(NSIndexPath*)indexPath
{
    return 44;
}

- (void)tableView:(UITableView*)tableView didSelectRowAtIndexPath:(NSIndexPath*)indexPath
{
    [self.tableView deselectRowAtIndexPath:[NSIndexPath indexPathForRow:selectedIndex inSection:0] animated:YES];
    selectedIndex = indexPath.row;
    selectedSleepTime = arr[indexPath.row];
}

- (void)getSleepTime
{
    [self showHudWithAnimated:YES];
    [WIFIPasswordSetting openWIFISocketwithMode:GOSocketModeWIFIManager
                                        success:^{ //打开socket成功后请求接头现在的休眠时间
                                                [WIFIPasswordSetting QueryConnectorSleepTime:_serialNO
                                                                                success:^(NSInteger time) {
                                                                                    [self hidenHudWithAnimated];
                                                                                    selectedSleepTime = [NSString stringWithFormat:@"%@",@(time)];
                                                                                    [self.tableView reloadData];
                                                                                }
                                                                                   fail:^{
                                                                                       [self hidenHudWithAnimated];
                                                                                       [self showAertWithTitle:nil message:@"获取休眠时间失败"];
                                                                                   }];
                                                }
                                        fail:^{
                                            [_hud setHidden:YES];
                                            [self showAertWithTitle:nil message:@"请连接golo接头的WIFI"];
                                        }];
}

- (void)btnSubmitClick
{
    if (selectedSleepTime.length > 0) {
        [self showHudWithAnimated:YES];
        [WIFIPasswordSetting setConnectorSleepTime:_serialNO
                                            minute:[selectedSleepTime intValue]
                                           success:^{
                                               [_hud setHidden:YES];
                                               [self showAertWithTitle:nil message:@"设置成功"];
                                           }
                                              fail:^{
                                                  [_hud setHidden:YES];
                                                  [self showAertWithTitle:nil message:@"设置失败"];
                                              }];
    }
    else {
        [self showAertWithTitle:nil message:@"请先选中一个时间"];
    }
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
