//
//  GOWIFIManagerViewController.m
//  GODiagnoseDemo
//
//  Created by Launch Tech Co.,Ltd on 4/8/15.
//  Copyright (c) 2015 allen. All rights reserved.
//

#import "GOWIFIManagerViewController.h"
#import "UIViewController+Extension.h"
#import "MBProgressHUD+Golo.h"
#import "WIFIPasswordSetting.h"

static NSString * kAlphaNum =  @"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
#define BorderLineCGColor                       ([UIColor colorWithRed:198./255. green:198./255. blue:198./255. alpha:1].CGColor)

@interface GOWIFIManagerViewController ()<UITextFieldDelegate>
{
    MBProgressHUD *_hud;
}
@property (strong, nonatomic) WIFIPasswordSetting *wifiPWsetting;

@end

@implementation GOWIFIManagerViewController
- (void)dealloc
{
    NSLog(@"%s",__func__);
    [WIFIPasswordSetting closeWIFISocket];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
     self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"确定" style:UIBarButtonItemStyleDone target:self action:@selector(btnSubmitClick)];
    
    _wifiNameTextField.layer.borderWidth = 1.;
    _wifiNameTextField.layer.borderColor = BorderLineCGColor;
    
    _wifiPasswdTextField.layer.borderWidth = 1.;
    _wifiPasswdTextField.layer.borderColor = BorderLineCGColor;
    
    _wifiNameTextField.delegate = self;
    _wifiPasswdTextField.delegate = self;
    
    _wifiNameTextField.keyboardType = UIKeyboardTypeASCIICapable;
    _wifiPasswdTextField.keyboardType = UIKeyboardTypeASCIICapable;
    
    [self getWIFIInfo];
}

#pragma mark - Table view data source

- (CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section
{
    return 0.1;
}

- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section
{
    return 0.1;
}

- (void)getWIFIInfo
{
    _hud = [MBProgressHUD showHudOnView:self.view animated:YES];
    [WIFIPasswordSetting openWIFISocketwithMode:GOSocketModeWIFIManager success:^{   
        [WIFIPasswordSetting getWIFINameAndPass:_serialNO
                                        success:^(NSDictionary *wifidic) {
                                            [_hud setHidden:YES];
                                            if (wifidic && [wifidic isKindOfClass:[NSDictionary class]]) {
                                                _wifiNameTextField.text = [wifidic objectForKey:@"wifiname"];
                                                _wifiPasswdTextField.text = [wifidic objectForKey:@"wifipassw"];
                                                [self.tableView reloadData];
                                            }
                                        } failure:^(NSError *error) {
                                            [_hud setHidden:YES];
                                            [self showAertWithTitle:nil message:@"获取WIFI信息失败"];
                                        }];
    } fail:^{
        [_hud setHidden:YES];
        [self showAertWithTitle:nil message:@"请连接golo接头的WIFI"];
    }];
}

- (void)btnSubmitClick
{
    [self.view endEditing:YES];
    if (_wifiPasswdTextField.text.length < 8 || _wifiPasswdTextField.text.length > 16) {
        [self showAertWithTitle:nil message:@"请输入8-16位的密码"];
        return;
    }
    if (_wifiNameTextField.text.length < 8 || _wifiNameTextField.text.length > 16) {
         [self showAertWithTitle:nil message:@"请输入8-16位的WiFi热点名称"];
        return;
    }
    NSLog(@"wifiName == %@  && Password == %@", _wifiNameTextField.text, _wifiPasswdTextField.text);
     _hud = [MBProgressHUD showHudOnView:self.view animated:YES];
    [WIFIPasswordSetting changeWIFIPasswordAndName:_wifiNameTextField.text
                                    wifiPassw:_wifiPasswdTextField.text
                                    serial_no:_serialNO
                                      success:^{
                                          _hud.hidden = YES;
                                          [self showAertWithTitle:nil message:@"修改成功"];
                                      } failure:^(NSError *error) {
                                          _hud.hidden = YES;
                                         [self showAertWithTitle:nil message:@"修改失败"];
                                      }];
}
- (BOOL)textField:(UITextField*)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString*)string
{
    NSCharacterSet* cs;
    cs = [[NSCharacterSet characterSetWithCharactersInString:kAlphaNum] invertedSet];

    NSString* filtered = [[string componentsSeparatedByCharactersInSet:cs] componentsJoinedByString:@""]; //按cs分离出数组,数组按@""分离出字符串

    BOOL canChange = [string isEqualToString:filtered];

    return canChange;
}

- (void)showAertWithTitle:(NSString *)title
                  message:(NSString *)message
{
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:title
                                                    message:message
                                                   delegate:nil
                                          cancelButtonTitle:@"确定"
                                          otherButtonTitles:nil, nil];
    [alert show];
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
