//
//  GOWIFISettingChooseController.m
//  GODiagnoseDemo
//
//  Created by Launch Tech Co.,Ltd on 11/27/15.
//  Copyright © 2015 allen. All rights reserved.
//

#import "GOWIFISettingChooseController.h"
#import "GOWIFIManagerViewController.h"
#import "GOSleepSettingViewController.h"
#import "UIViewController+Extension.h"
#import "MBProgressHUD+Golo.h"
#import "WIFIPasswordSetting.h"
@interface GOWIFISettingChooseController ()
{
    MBProgressHUD *_hud;
}
@end

@implementation GOWIFISettingChooseController

- (void)viewDidLoad {
    [super viewDidLoad];
    
}

- (IBAction)getOrChangeWIFINameAndPassword:(UIButton *)sender {
    
    UIStoryboard *board = [UIStoryboard storyboardWithName:@"Main" bundle:nil];
    GOWIFIManagerViewController *wifiMangerCtl = [board instantiateViewControllerWithIdentifier:@"WIFIManager"];
    wifiMangerCtl.serialNO = self.serialNO;
    [self.navigationController pushViewController:wifiMangerCtl animated:YES];
}

- (IBAction)setWIFIModelWithOpen:(UIButton *)sender {
    
    _hud = [MBProgressHUD showHudOnView:self.view animated:YES];
    _hud.hidden = NO;
    [WIFIPasswordSetting openWIFISocketwithMode:GOSocketModeWIFIManager success:^{
        [WIFIPasswordSetting passwordWithNone:_serialNO success:^{
            _hud.hidden = YES;
            [self tipsMessage:@"设置开放模式成功"];
        } failure:^(NSError *error) {
            [_hud setHidden:YES];
            [self showAertWithTitle:nil message:@"获取WIFI信息失败或接头已为开放模式"];
        }];
    } fail:^{
        [_hud setHidden:YES];
        [self showAertWithTitle:nil message:@"请连接golo接头的WIFI"];
    }];
}

- (IBAction)getOrSetGoloSleeptime:(UIButton *)sender {
    
    UIStoryboard *board = [UIStoryboard storyboardWithName:@"Main" bundle:nil];
    GOSleepSettingViewController* sleepSettingCtrl = [board instantiateViewControllerWithIdentifier:@"SleepSetting"];
    sleepSettingCtrl.serialNO = self.serialNO;
    [self.navigationController pushViewController:sleepSettingCtrl animated:YES];
}

- (void)showAertWithTitle:(NSString *)title message:(NSString *)message{
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:title
                                                    message:message
                                                   delegate:nil
                                          cancelButtonTitle:@"确定"
                                          otherButtonTitles:nil, nil];
    [alert show];
}
@end
